#!/usr/bin/env python

import sys
from proper import *

def t1(n,delta):
    return (2*n-1)*(n-1) - sum(d**2 for d in delta)//2

def main():
    if (len(sys.argv) <= 1):
        print("missing argument")
        sys.exit(1)

    n = int(sys.argv[1])

    G1 = {}
    for p in partitions(n-2):
        delta = degreesequence(p)
        alpha = occupations(n,delta)
        
        G = 2**(n-1)*multinomial(alpha)*multinomial(p)//n
        t = t1(n,delta)
        
        G1.setdefault(t,0)
        G1[t] += G

    for t in sorted(G1):
        print("%s %s" % (t, G1[t]))

if __name__ == "__main__":
    main()
